#!/usr/bin/perl


sub physical_volume_table {
  &get_physical_volume_list();

  if($pv_count == 0){
    print "<p>$text{'no_physical_volume'}<br>";
    return;
  }

  print "<p>";
  print "<table border width=100%>\n";
  print "<caption><b>$text{'pv_table'}</b></caption>";
  
  print "<tr $tb> <td><b>$text{'pv_name'}</b></td> ", 
    "<td><b>$text{'vg_status'}</b></td>",
      "<td><b>$text{'vg_name'}</b></td>",
	"<td><b>$text{'total_size'}</b></td>",
	  "<td><b>$text{'used_size'}</b></td>",
	    "<td><b>$text{'free_size'}</b></td>",
	      " </tr>\n"; 
  
  for($i = 0; $i <  $pv_count; $i++) {
    
    my $status_string = $text{@vg_status[$i]};

    if((@vg_name[$i] ne "") && (@pv_total_size_unit[$i] eq @pv_free_size_unit[$i])){
      $used_size = @pv_total_size[$i] - @pv_free_size[$i]; 
      $used_size = $used_size." ".@pv_total_size_unit[$i];
    } else {
      $used_size = "---";
    }
    
    if(@vg_name[$i] eq "") {
      $pr_vg_name = "---";
      $pr_free_size = "---";
    } else {
      $pr_vg_name = @vg_name[$i]; 
      $pr_free_size = @pv_free_size[$i]." ".@pv_free_size_unit[$i];
    }

    print "<tr $cb><td>",@pv_name[$i],"</td>",
#    print "<tr $cb><td>",&build_pv_url(@pv_name[$i],@vg_status[$i]),"</td>",
      "<td>",$status_string,"</td>",
	"<td>",$pr_vg_name,"</td>",
	  "<td>",@pv_total_size[$i]." ".@pv_total_size_unit[$i],"</td>",
	    "<td>",$used_size,"</td>",
	    "<td>",$pr_free_size,"</td>",
		"</tr>\n";
  }
  
  print "</table><p>\n";

}

sub get_physical_volume_list {
  system("pvscan > pvscan.tmp");
  open(PVSCAN,"pvscan.tmp");

  $pv_count = 0;
  while(<PVSCAN>){
    if(/^pvscan -- (\S*) *PV "(.*)".*"(.*)".*\[(\d+\.*\d*) (\S*) \/ (\d+\.*\d*) (\S*)/){
      @vg_status[$pv_count] = $1;
      @pv_name[$pv_count] = $2;
      @vg_name[$pv_count] = $3;
      @pv_total_size[$pv_count] = $4;
      @pv_total_size_unit[$pv_count] = $5;
      @pv_free_size[$pv_count] = $6;
      if($6 != 0) {
	@pv_free_size_unit[$pv_count] = $7;
      } else {
        @pv_free_size_unit[$pv_count] = $5; 
      }
      $pv_count++;
    } elsif(/^pvscan -- (\S*) PV "(.*)".*\[(\d+\.*\d*) (.*)\]/) {
      @vg_status[$pv_count] = $1;
      @pv_name[$pv_count] = $2;
      @vg_name[$pv_count] = "";
      @pv_total_size[$pv_count] = $3;
      @pv_total_size_unit[$pv_count] = $4;
      $pv_count++; 
    }
  }
  system("rm -f pvscan.tmp");
}

sub build_pv_url {
  my $name = $_[0];
  "<a href=\"edit_pv.cgi?name=$name\">$name</a>";
}


#--------------------------------------------------

sub volume_group_table {

  &get_volume_group_list();

  if($vg_count == 0){
    print "<p>$text{'no_volume_group'}<br>";
    return;
  }
  
  print "<p>";
  print "<table border width=100%>\n";
  print "<caption><b>$text{'vg_table'}</b></caption>";

  print "<tr $tb> <td><b>$text{'vg_name'}</b></td> ", 
    "<td><b>$text{'vg_status'}</b></td> </tr>\n"; 
  
  for($i = 0; $i <=  $vg_count; $i++) {
    
    my $status_string = $text{@vgstatus[$i]};

    print "<tr $cb><td>",&build_vg_url(@vgname[$i],@vgstatus[$i]),
      "</td><td>",$status_string,"</td></tr>\n";
  }
  
  print "</table><p>\n";
}

sub get_volume_group_list{
  system("vgscan > vgscan.tmp");
  open(VGSCAN,"vgscan.tmp");
  
  $vg_count = 0;
  
  while (<VGSCAN>) {
    if(/^vgscan -- found (\S*) .*"(.*)"/) {
      @vgstatus[$vg_count] = $1;
      @vgname[$vg_count] = $2;
      $vg_count++;
    }
  }
  system("rm -f vgscan.tmp");
}

sub edit_volume_group{
  my $vg_name = $_[0];  
  system("vgdisplay -c $vg_name > vgdisplay.tmp");  
}

# test driver
#foreach(&get_vg_status('nonaka_vg')){print $_,"\n";};

sub build_vg_url {
  my $vg_name = $_[0];
  my $vg_status = $_[1];
  "<a href=\"edit_vg.cgi?vg_name=$vg_name&status=$vg_status\">$vg_name</a>";
}

sub get_vg_status{
  my $vg_name = $_[0];
  
  system("vgdisplay -c $vg_name > vgdisplay.tmp");

  open(VGDISPLAY, "vgdisplay.tmp");

  while(<VGDISPLAY>) {
    if(/^$vg_name:/){
      @result = split(/:/);
    }
  }
  system("rm -f vgdisplay.tmp");
  @result;
}

#--------------------------------------------------

sub logical_volume_table {

  &get_logical_volume_list();

  if($lv_count == 0){
    print "<p>$text{'no_logical_volume'}<br>";
    return;
  }
  
  print "<p>";
  print "<table border width=100%>\n";
  print "<caption><b>$text{'lv_table'}</b></caption>";

  print "<tr $tb> <td><b>$text{'lv_name'}</b></td> ", 
    "<td><b>$text{'lv_status'}</b></td>\n", 
    "<td><b>$text{'size'}</b></td> </tr>\n"; 
  
  for($i = 0; $i <=  $lv_count; $i++) {
    
    my $status_string = $text{@lvstatus[$i]};

    print "<tr $cb><td>",&build_lv_url(@lvname[$i]),
      "</td><td>",$status_string,"</td>",
      "</td><td>","$lvsize[$i] $lvsize_unit[$i]","</td></tr>\n";
  }
  
  print "</table><p>\n";
}


sub get_logical_volume_list{
  system("lvscan > lvscan.tmp");
  open(LVSCAN,"lvscan.tmp");
  
  $lv_count = 0;
  
  while (<LVSCAN>) {
    if(/^lvscan -- (\S*) .*"(.*)".*\[(\d+\.*\d*) *(\S*)\]/) {
      @lvstatus[$lv_count] = $1;
      @lvname[$lv_count] = $2;
      @lvsize[$lv_count] = $3;
      @lvsize_unit[$lv_count] = $4;
      $lv_count++;
    }
  }
  system("rm -f lvscan.tmp");
}

sub build_lv_url {
  my $lv_name = $_[0];
  "<a href=\"edit_lv.cgi?lvname=$lv_name\">$lv_name</a>";
}

#@r = &get_lv_status("/dev/nonaka_vg1/nonaka_lv1");
#print @r;

sub get_lv_status{
  my $lv_path = $_[0];
  
  system("lvdisplay -c $lv_path > lvdisplay.tmp");

  open(LVDISPLAY, "lvdisplay.tmp");

  while(<LVDISPLAY>) {
    if(/^$lv_path:/){
      @result = split(/:/);
    }
  }
  system("rm -f lvdisplay.tmp");
  @result;
}
