#!/usr/local/bin/ruby

require "cgi"

cgi = CGI.new("html3")

class PhysicalVolume
  attr_accessor :device_name, :total_size, :free_size, :unit, :volume_group
  def initialize(device_name,total_size,free_size,unit,volume_group)
    @device_name = device_name
    @total_size = total_size
    @free_size = free_size
    @unit = unit
    @volume_group = volume_group
  end
end

class VolumeGroup
  attr_accessor :name, :status
  def initialize(name,status)
    @name = name
    @status = status
  end
end

class LogicalVolume
  attr_accessor :full_path, :vg_name, :lv_name, :size, :unit
  def initialize(name,size,unit)
    @full_path = name
    name =~ '/.*/(.*)/(.*)'
    @vg_name = $1
    #puts $1
    @lv_name = $2
    #puts $2
    @size = size
    @unit
  end
end

def pvscan
  $pv_count = 0
  $pv_hash = Hash.new()
  $vg_hash = Hash.new()
  lines = `pvscan`
  
  lines.each do | aLine |
    if aLine =~ /^pvscan -- (\S*).*"(.*)".*"(.*)"\D+(\d+[.]*\d*) +(\w*)\D+(\d+[.]*\d*)/
      status  = $1
      device_name = $2
      vg_name = $3
      total_size = $4
      unit = $5
      free_size = $6
      $vg_hash[vg_name] = volume_group = VolumeGroup.new(vg_name,status)
      $pv_hash[device_name] = PhysicalVolume.new(device_name,total_size,free_size,unit,volume_group)
      $pv_count += 1
    end
  end
end

def lvscan
  $lv_count = 0
  $lv_hash = Hash.new()
  lines = `lvscan`
  lines.each do | aLine |
    if aLine =~ /^lvscan -- (\S*).*"(.*)"\D*(\d+[.]*\d*) +(\w+)/
      status = $1
      name = $2
      size = $3
      unit = $4
      $lv_hash[name] = LogicalVolume.new(name,size,unit)
      $lv_count += 1
    end
  end
end

def create_table_data(arg)
  print "<td>"
  print arg
  print "</td>"
end

def create_table_row(arg, bgcolor)
  puts "<tr bgcolor=#{bgcolor}>"
  print "  " 
  arg.each do | x |
    create_table_data(x)
  end
  puts
  puts "</tr>"
end

def create_table(caption,header,data)
  puts "<p>"
  puts "<table border=1 width=100%>"
  puts "<caption> #{caption} </caption>"
  create_table_row(header,"#9999ff")
  data.each do | x |
    create_table_row(x,"#cccccc")
  end
  puts "</table>"
end

pvscan
lvscan

pv_table_header = ["Device","Status","Volume Group","Total","Used","Free"]
pv_caption = "Physical Volume Status"

pv_table_data = []
$pv_hash.each_value do | x |
  total = x.total_size.to_i
  free = x.free_size.to_i
  used = total - free
  pv_table_data.push  [x.device_name,x.volume_group.status,x.volume_group.name,total,used, free]
end

create_table(pv_caption,pv_table_header,pv_table_data)

lv_table_header = ["Logical Volume Name","Volume Group","Status","Size"]
lv_caption = "Logocal Volume Status"

lv_table_data = []
$lv_hash.each_value do | x |
  lv_table_data.push [x.full_path, x.vg_name,$vg_hash[x.vg_name].status, x.size]
end

create_table(lv_caption,lv_table_header,lv_table_data)
